local x, y
local button
local unit_mark_index
local unit_mark_texture

function SetBackdropColor(frm, frm_r, frm_g, frm_b, frm_a)
	if not frm.Backdrop then
		frm.Backdrop = CreateFrame("Frame", frm:GetName().."_Backdrop", frm, "BackdropTemplate")
		frm.Backdrop:SetAllPoints()
		frm.Backdrop.backdropInfo = {
			bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
			edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
			tile = true,
			tileSize = 32,
			edgeSize = 32,
			insets = { left = 11, right = 12, top = 12, bottom = 9, },
		}
		frm.Backdrop:SetBackdrop(frm.Backdrop.backdropInfo)
	end
	
	frm.Backdrop:SetBackdropColor(frm_a, frm_g, frm_b, frm_a)
	frm.Backdrop:SetBackdropBorderColor(frm_a, frm_g, frm_b, frm_a)
end

	for i = 1, 5 do
		unit = "Party"..i
		
		if i == 5 then
			unit = "Player"
		end

		if unit == "Player" then
			x = -150
			y = 0
			button = CreateFrame("BUTTON", "IconMarksPlayerIcon", GetClickFrame("PlayerFrame"), "SecureActionButtonTemplate")
			button:SetPoint("TOPRIGHT", "PlayerFrame", "TOPRIGHT", x, y)
			SetBackdropColor(button, 0.1, 0.1, 0.1, 0)
			button:SetWidth(17)
			button:SetHeight(17)			
			button:SetNormalTexture("")
			button:SetFrameLevel(128)
			button:SetScript("OnEvent", IconMarks_OnEvent)
		else	
			x = -96
			y = 6
			button = CreateFrame("BUTTON", "IconMarksParty"..i.."Icon", GetClickFrame("PartyMemberFrame"..i), "SecureActionButtonTemplate")
			button:SetPoint("TOPRIGHT", "PartyMemberFrame"..i, "TOPRIGHT", x, y)
			SetBackdropColor(button, 0.1, 0.1, 0.1, 0)
			button:SetWidth(13)
			button:SetHeight(13)				
			button:SetNormalTexture("")
			button:SetFrameLevel(128)
		end
	end
	
print("IconMarks loaded ...")

local IconMarks_timer = CreateFrame("Frame");
IconMarks_timer:SetScript("OnUpdate", function(self, sinceLastUpdate) IconMarks_timer:onUpdate(sinceLastUpdate); end);

function IconMarks_timer:onUpdate(sinceLastUpdate)

	self.sinceLastUpdate = (self.sinceLastUpdate or 0) + sinceLastUpdate
	
	if (self.sinceLastUpdate >= 5) then 
	
	for i = 1, 5 do
		unit = "Party"..i
		
		if i == 5 then
			unit = "Player"
		end
				
		if UnitExists(unit) then
			
			unit_mark_index = nvl(GetRaidTargetIndex(unit), 0)
			unit_mark_texture = ""
			
			if unit_mark_index ~= 0 then
				unit_mark_texture = "Interface\\TargetingFrame\\UI-RaidTargetingIcon_"..unit_mark_index
			else
				unit_mark_texture = ""
			end	
			
			if unit == "Player" then
				GetClickFrame("IconMarksPlayerIcon"):SetNormalTexture(unit_mark_texture)
			else
				GetClickFrame("IconMarksParty"..i.."Icon"):SetNormalTexture(unit_mark_texture)			
			end				
		end		
	end
		self.sinceLastUpdate = 0;
	end
end

function nvl(arg1, arg2)
	if arg1 == nil then
		return arg2
	else
		return arg1
	end
end